#include <math.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <values.h>
#include<stdlib.h>

// #include "externals.h" vire (loic)
#include "yonly.h"

#define IMAGEDIM 200

/*** declaration of global variables ***/
int	varnb, termnb, layernb, simfun, ltrace=0, initype=0;
static	long	k=0, kf=0;
double	*x, y, g, gbar, *w, **t, **s, **r,
  *xmin, *xmax, ymin, ymax, gam, gam0, gam1,
  epsilon, volume, ksi, domainmin,
  domainmax, *xcent, *xampl, ycent, yampl;
	

double	**affine;

FILE	*fpout;


FILE	*fpinput;
int	pdisp;

double	**xobs, *yobs;
int	obsnb;
char	obsfile[64];

int	icontrol;


float
yonly(void)
{
  static	int	itpt=0;
  double	xlc, ylc, step, wnet(double *xvec); 
  static	double	xminlc=-1.0, xmaxlc=1.0;



  if(itpt == 0)
    {
      learn();
    }
 
  step = (xmaxlc-xminlc) / (double)(IMAGEDIM-1);
  xlc = xminlc + (double)itpt * step;
 
 
  ylc = wnet(&xlc);

 
  itpt++;
 
  if(itpt >= IMAGEDIM)
    {
      itpt = 0;
    }
  return((float)ylc);
}



/******************************************************************************
	Wavelet network for approximation
        forward()
        by Qinghua ZHANG
        Last change: 2 April 1991
*******************************************************************************/



double
forward(double *x)
{
  int	l;
  double	rval, *xt, *xr, *xd,
    wavelet(double *xvec);
 
  xt = (double *)calloc((unsigned)varnb, sizeof(double));
  xr = (double *)calloc((unsigned)varnb, sizeof(double));
  xd = (double *)calloc((unsigned)varnb, sizeof(double));

  rval = gbar;
  for(l=0; l<termnb; l++)
    {
      submm(xt, x, t[l], varnb, 1);
      multmm(xr, r[l], xt, varnb, varnb, 1);
      divivv(xd, xr, s[l], varnb);
      rval = rval + w[l] * wavelet(xd);
    }
  (void)cfree(xt); (void)cfree(xr); (void)cfree(xd); 
  return(rval);
}
/******************************************************************************
	Wavelet network for approximation
        init()
        by Qinghua ZHANG
        Last change: 14 May 1991
*******************************************************************************/


struct	treestruct
{
  int		father;
  int		rank;
  double	location[3];
} **tree;

int	edge, lg, *ind, initnb;
double	*svd;

void
init(void)
{
  int	i, l, ly, lf, lr, j;
  double	pointe(int varind, int termind);

  if((varnb == 1) && (simfun != 0)) svdensity();

  edge = intpow(2, layernb) - 1;
 
  /*** memory allocation ***/
  tree = (struct treestruct **)calloc((unsigned)varnb,
				      sizeof(struct treestruct));
  for(i=0; i<varnb; i++)
    {
      tree[i] = (struct treestruct *)calloc((unsigned)edge,
					    sizeof(struct treestruct));
    }
  ind = (int *)calloc((unsigned)varnb, sizeof(int));
 
  /*** tree construction ***/
  for(i=0; i<varnb; i++)
    {
      l = 1;
      for(ly=1; ly<layernb; ly++)
	{
	  for(lf=intpow(2, (ly-1))-1; lf<intpow(2, ly)-1; lf++)
	    {
	      for(lr=0; lr<2; lr++)
		{
		  tree[i][l].father = lf;
		  tree[i][l].rank = lr;
		  l++;
		}
	    }
	}
    }
  
  for(i=0; i<varnb; i++)
    {
      tree[i][0].location[0] = -1.0;
      tree[i][0].location[2] = 1.0;
      tree[i][0].location[1] = pointe(i, 0);
  
      for(l=1; l<edge; l++)
	{
	  lf = tree[i][l].father;
	  lr = tree[i][l].rank;
   
	  tree[i][l].location[0] = tree[i][lf].location[lr];
	  tree[i][l].location[2] = tree[i][lf].location[lr+1];
	  tree[i][l].location[1] = pointe(i, l);
	}
    }
 
  /*** regular terms ***/
  lg = 0;
  setregularterm(0);
   
  /*** irregular terms ***/
  for(l=lg; l<termnb; l++)
    {
      for(i=0; i<varnb; i++)
	{
	  t[l][i] = rndunif(-1.0, 1.0);
	  s[l][i] = ksi * 2.0 * pow(2.0, -(double)layernb);
	}
    }
 
  gbar = 0.0;
  for(l=0; l<termnb; l++)
    {
      w[l] = 0.0;
      for(i=0; i<varnb; i++)
	{
	  for(j=0; j<varnb; j++)
	    {
	      r[l][i * varnb + j] = (i==j)?1.0:0.0;
	    }
	}
    }
 
  for(i=0; i<varnb; i++)
    {
      cfree(tree[i]);
    }
  cfree(tree); cfree(ind); cfree(svd);
}

double
pointe(int varind, int termind)
{
  double	rval, delt, middle;
  int	i, left, right;
 
  if((varnb == 1) && (simfun != 0))
    {
      delt = 2.0 / (double)initnb;
      left = (int)((tree[varind][termind].location[0] + 1.0) / delt + 0.5);
      right = (int)((tree[varind][termind].location[2] + 1.0) / delt + 0.5);
      if(right >= initnb) right = initnb - 1;
   
      middle = 0.5 * (svd[left] + svd[right]);
      for(i=left; i<=right; i++)
	{
	  if(svd[i] > middle)
	    {
	      rval = (((double)i - 0.5) * delt - 1.0);
	      break;
	    }
	}
    }
  else
    {
      rval = 0.5 * (tree[varind][termind].location[0] +
		    tree[varind][termind].location[2]);
    }
 
  return(rval);
}




setregularterm(int dim)
{
  int	i;

  for(ind[dim]=0; ind[dim]<edge; ind[dim]++)
    {
      if(dim < varnb-1)
	{
	  setregularterm(dim+1);
	}
      else
	{
	  for(i=0; i<varnb; i++)
	    {
	      t[lg][i] = tree[i][ind[i]].location[1];
	      s[lg][i] = ksi *
       		(tree[i][ind[i]].location[2]-tree[i][ind[i]].location[0]);
	    }
	  lg++;
	}
    }
}


svdensity(void)
{
  double	step, xcurrent, xprev, simulation(double *xsim);
  int	i;
 
  initnb = intpow(2, layernb+4);
  svd = (double *)calloc((unsigned)initnb, sizeof(double));
 
  step = (xmax[0]-xmin[0]) / (double)initnb;
 
  svd[0] = 0.0;
  xcurrent = xmin[0];
  for(i=1; i<initnb; i++)
    {
      xprev = xcurrent;
      xcurrent = xmin[0] + (double)i * step;
   
      svd[i] = svd[i-1] + fabs(simulation(&xcurrent) - simulation(&xprev));
    }
}



/******************************************************************************
	Wavelet network for approximation
        input.c
        by Qinghua ZHANG
        Last change: 3 April 1991
*******************************************************************************/




void
input1(void)
{
  char	*parafile;
  long	getlong(void);
	
  /*** get the name of parameter file ***/
  parafile = "demownet.par";
 
 
 
  /*** open  parameter file ***/
  fpinput = fopen(parafile, "r");
 
  /*** simulated function number ***/
  readlong(fpinput, (long *)&simfun, 1);
 
 
  /*** number of variable ***/
  readlong(fpinput, (long *)&varnb, 1);
 
  /*** number of terms ***/
  readlong(fpinput, (long *)&termnb, 1);
 
 
  /*** period for displaying the learning computing ***/
  readlong(fpinput, (long *)&pdisp, 1);
}

void
input2(void)
{
  int	i;
  double	volumecoeff;
  char	str[16];
  double xxx;
  double yyy;
 
  /*** domain of approximation ***/
  readdouble(fpinput, xmin, varnb);
  readdouble(fpinput, xmax, varnb);
 
  /*** range ***/
  readdouble(fpinput, &ymin, 1);
  readdouble(fpinput, &ymax, 1);
 
 
  /*** learning algorithm parameters ***/
  readdouble(fpinput, &gam0, 1);
  readdouble(fpinput, &gam1, 1);
  readdouble(fpinput, &epsilon, 1);
  readdouble(fpinput, &volumecoeff, 1);
  readdouble(fpinput, &ksi, 1);
 
  /*** test data end ***/
  if(testend(fpinput, "Parameter file incorrect"))
    {
      exit(8);
    }

  (void)fclose(fpinput);

  
  /*** other parameters ***/
  yyy = (double) ((double)1.0 / (double)varnb);
  xxx = pow((double)termnb, yyy);
  //  layernb = (int)log2( xxx + (double)1.0); ne marche pas 
  layernb = (int)log( xxx + (double)1.0);
  domainmin = -1.5;
  domainmax = 1.5;
  volume = volumecoeff * pow((double)layernb, (double)varnb);
 
  /*** scales ***/
  for(i=0; i<varnb; i++)
    {
      xcent[i] = 0.5 * (xmin[i] + xmax[i]);
      xampl[i] = 2.0 / (xmax[i] - xmin[i]);
    }
 
  ycent = 0.5 * (ymin + ymax);
  yampl = 2.0 / (ymax - ymin);
}
/******************************************************************************
	Wavelet network for approximation
        main programmme for learning
        by Qinghua ZHANG
        Last change: 5 April 1991
*******************************************************************************/
void 
learn(void)
{
  int	i, l, kcycle;
  void	input1(void), input2(void), rog(void), init(void), observer(void), update(void),
    output(), writeresult(void);
	
  static	int	startprog=0, pcycle=1;

 	
  /*** set the random generator ***/
  if(startprog==0)
    {
      startprog = 1;
      srandom(getpid());
   
   
 
      /*** input parameters ***/
      input1();
 
 
 
      /*** memory allocation ***/
      w = (double *)calloc((unsigned)termnb, sizeof(double));
      t = (double **)calloc((unsigned)termnb, sizeof(double *));
      s = (double **)calloc((unsigned)termnb, sizeof(double *));
      r = (double **)calloc((unsigned)termnb, sizeof(double *));
      for(i=0; i<termnb; i++)
	{
	  t[i] = (double *)calloc((unsigned)varnb, sizeof(double));
	  s[i] = (double *)calloc((unsigned)varnb, sizeof(double));
	  r[i] = (double *)calloc((unsigned)(varnb * varnb), sizeof(double));
	}
      x = (double *)calloc((unsigned)varnb, sizeof(double));
      xmin = (double *)calloc((unsigned)varnb, sizeof(double));
      xmax = (double *)calloc((unsigned)varnb, sizeof(double));
      xcent = (double *)calloc((unsigned)varnb, sizeof(double));
      xampl = (double *)calloc((unsigned)varnb, sizeof(double));
   
      affine = (double **)calloc((unsigned)termnb, sizeof(double *));
      for(l=0; l<termnb; l++)
	{
	  affine[l] = (double *)calloc((unsigned)(varnb * varnb), sizeof(double));
	}
 
      /*** input other parameters ***/
      input2();
 
      /*** initialise the random observation generator ***/
      if(simfun == 0)
	{
	  rog();
	}
 
 
 
      /*** initialise the network ***/
      init(); 
    }
  kf = kf + 1;
  /****** if(kf>=102) pcycle = 5;
	  if(kf>200) pcycle = 50; *******/
  if(kf>=200) pcycle = 10;
  /*** beginning of the main loop ***/
  for(kcycle=0; kcycle<pcycle; kcycle++)
    {
     
     
      k = k + 1;
     
      if(k==1) break;
     
      /*** get a observation sample ***/
      observer();
   
      /*** learning gain ***/
      if(k < 19)
	{
	  gam = gam0;
	}
      else
	{
	  gam = gam0 * pow(0.9999, (double)(k-19)) + gam1 / ((double)k) + 0.001;
	}
   
      /*** up to date the coefficients ***/
      update();
    }
  /*** end of the main loop ***/
 
  writeresult();
 
}
/******************************************************************************
	Wavelet network for approximation
        lib.c
        by Qinghua ZHANG
        Last change: 3 April 1991
*******************************************************************************/



/************************ addition of two matrix ******************************/ 
/*  mat1 and mat2 are two m-by-n matrix, sum = mat1 + mat2                    */
addmm(double *sum, double *mat1, double *mat2, int m, int n)
{
  int l;

  for(l=0; l<(m * n); l++) sum[l] = mat1[l] + mat2[l];
}

/************************ substraction of two matrix *************************/
/*  mat1 and mat2 are two m-by-n matrix, sum = mat1 - mat2                   */
submm(double *sum, double *mat1, double *mat2, int m, int n)
{
  int l;

  for(l=0; l<(m * n); l++) sum[l] = mat1[l] - mat2[l];
}

/************************ Multiplication of two matrix ***********************/
/* fac1 and fac2 are two matrix m-by-l and l-by-n respectively,
   prod is the product of fac1 and fac 2 (m-by-n)               */
multmm(double *prod, double *fac1, double *fac2, int m, int l, int n)
{
  int i, j, km;
  double *buf;
  buf = (double *)calloc((unsigned)(m * n), sizeof(double));
  for(i=0; i<m; i++)
    {
      for(j=0; j<n; j++)
	{
	  buf[n * i + j] = 0.0;
	  for(km=0; km<l; km++)
	    buf[n * i + j] = buf[n * i + j] + fac1[l * i + km] * fac2[km * n + j];
	}
    }
  for(km=0; km<(m * n); km++) prod[km] = buf[km];
 
  cfree(buf);
}

/************************* Transpose of a matrix *****************************/
/* mat is a m-by-n matrix, trp point to its transpose (n-by-m)              */
transp(double *trp, double *mat, int m, int n)
{
  int i, j;
  double *buf;
  buf = (double *)calloc((unsigned)(m * n), sizeof(double));
  for(i=0; i<(m * n); i++)  buf[i] = mat[i];
  for(i=0; i<m; i++)
    {
      for(j=0; j<n; j++)
	{
	  trp[m * j + i] = buf[n * i + j];
	}
    }
 
  cfree(buf);
}


/****************** multiplication scalar * matrix ***************************/
/*  s is a scalar, mat is a m-by-n matrix, prod   point to   s * mat         */
multsm(double *prod, double s, double *mat, int m, int n)
{
  int l;
  for(l=0; l<(m * n); l++) prod[l] = s * mat[l];
}

/******************multiplication of two vectors element by element **********/
/* prod = vec1 * vec2							*/
multvv(double *prod, double *vec1, double *vec2, int n)
{
  int	l;

  for(l=0; l<n; l++)
    {
      prod[l] = vec1[l] * vec2[l];
    }
} 


/******************division of two vectors element by element ****************/
/* prod = vec1 / vec2							*/
divivv(double *prod, double *vec1, double *vec2, int n)
{
  int	l;

  for(l=0; l<n; l++)
    {
      prod[l] = vec1[l] / vec2[l];
    }
}

/****************** infinite norm of matrix ***********************************/
/*  infnormat(A) = max[i](sum[j](|a(i,j)|)) 				*/
double
infnormat(double *mat, int m, int n)
{
  int	i, j;
  double	sum1, sum2;

  sum1 = 0.0;
  for(i=0; i<m; i++)
    {
      sum2 = 0.0;
      for(j=0; j<n; j++)
	{
	  sum2 = sum2 + fabs(mat[i * n + j]);
	}
      if(sum1 < sum2) sum1 = sum2;
    }
  return(sum1);
}

/************* integer power *************************************************/
/*   base ** puss 							*/
int
intpow(int base, int puss)
{
  int	l, rval;

  rval = 1;
  for(l=0; l<puss; l++)
    {
      rval = rval * base;
    }
  return(rval);
}


/***** Pseudo-aleatoire number equiprobable in [min, max] ********************/
double
rndunif(double min, double max)
{
  long	random(void);
  return(min + ((double)random() / (double)MAXLONG) * (max - min));
}


/***** read from fp elemnb long integers and stock them in longpt ************/
int
readlong(FILE *fp, long int *longpt, int elemnb)
{
  char	str[128], *ptr[128];
  int	l;
  long	strtol(const char *, char **, int);

  for(l=0; l<elemnb; l++)
    {
      do
	{
	  (void)fscanf(fp, "%s", str);
	  if(feof(fp))  return(1);
	  longpt[l] = strtol(str, ptr, 10);
	}
      while(**ptr != '\0');
    } 
  return(0);
}


/***** read from fp elemnb double reals and stock them in doublept ***********/
int
readdouble(FILE *fp, double *doublept, int elemnb)
{
  char	str[128], *ptr[128];
  int	l;
  double	strtod(const char *, char **);

  for(l=0; l<elemnb; l++)
    {
      do
	{
	  (void)fscanf(fp, "%s", str);
	  if(feof(fp))  return(1);
	  doublept[l] = strtod(str, ptr);
	}
      while(**ptr != '\0');
    }
  return(0);
}


/*** print to fp nb elements of arr with cstr format *************************/
writedouble(FILE *fp, char *cstr, double *arraypt, int nb)
{
  int     i;
  for(i=0; i<nb; i++) (void)fprintf(fp, cstr, arraypt[i]);
}

/*** test the end of a data file by the word "endofdata" ***/
/*  return 1 when error, 0 when correct */
int
testend(FILE *fp, char *errmsg)
{
  char    str[16];
  (void)fscanf(fp, "%s", str);
  if(strcmp(str, "endofdata"))
    {
      putchar(7);
      (void)fprintf(stderr, "%s.\n", errmsg);
      return(1);
    }
  return(0);
}

long
getlong(void)
{
  char    str[64], *ptr[64];
  long	longint;
  long    strtol(const char *, char **, int);

  do
    {
      (void)scanf("%s", str);
      longint = strtol(str, ptr, 10);
      if(**ptr != '\0')
	{
	  putchar(7);
	  (void)printf("Not an integer entered. Try again: ");
	}
    }
  while(**ptr != '\0');
  return(longint);
}


getfilename(char *filename)
{
  (void)scanf("%s", filename);
  while(access(filename, 4))
    {
      (void)printf("Cannot open the file %s.\nTry with another one: ", filename);
      (void)scanf("%s", filename);
    }
}




/******************************************************************************
	Wavelet network for approximation
        observer()
        by Qinghua ZHANG
        Last change: 1 April 1991
*******************************************************************************/



void
observer(void)
{
  double	simulation(double *xsim), rndunif(double min, double max);
  int	i, l;
  long	random(void);

  if(simfun != 0)
    {
      for(i=0; i<varnb; i++)
	{
	  x[i] = rndunif(xmin[i], xmax[i]);
	}
      y = simulation(x);
   
      for(i=0; i<varnb; i++)
	{
	  x[i] = (x[i] - xcent[i]) * xampl[i];
	}
      y = (y - ycent) * yampl;
    }
  else
    {
      l = (int)random() % obsnb;
      for(i=0; i<varnb; i++)
	{
	  x[i] = xobs[l][i];
	}
      y = yobs[l];
    }
}
/******************************************************************************
	Wavelet network for approximation
        random observation generator
        by Qinghua ZHANG
        Last change: 5 April 1991
*******************************************************************************/


void
rog(void)
{
  int	i, j, columnb;
  char	ch, prevch;
  FILE	*fp;

  /*** get the name of observation file ***/
  (void)printf("obs file: ");
  getfilename(obsfile);
 
  /*** open obs file ***/
  fp = fopen(obsfile, "r");
 
  /*** test obs file format ***/
  readdouble(fp, x, 1);
  columnb = 1;
  prevch = '1';
  do
    {
      (void)fscanf(fp, "%c", &ch);
      if(prevch == ' ' && (('0' <= ch && ch <= '9') || ch == '.'))
	{
	  columnb = columnb + 1;
	}
      prevch = ch;
    }
  while(ch != '\n');
 
  if(varnb+1 != columnb)
    {
      (void)fprintf(stderr, "%s format error.\n", obsfile);
      exit(2);
    }
 
 
  puts("Random observation generator initialisation...");

  /*** get the number of observations ***/
  rewind(fp);
  obsnb = 0;
  while(!feof(fp))
    {
      readdouble(fp, x, varnb);
      if(readdouble(fp, &y, 1)) break;
   
      obsnb++;
    }
 
  /*** memory allocation ***/
  xobs = (double **)calloc((unsigned)obsnb, sizeof(double *));
  yobs = (double *)calloc((unsigned)obsnb, sizeof(double));
  for(i=0; i<obsnb; i++)
    {
      xobs[i] = (double *)calloc((unsigned)varnb, sizeof(double));
    }
  
  rewind(fp);
  for(i=0; i<obsnb; i++)
    {
      readdouble(fp, xobs[i], varnb);
      readdouble(fp, &yobs[i], 1);
   
      for(j=0; j<varnb; j++)
	{
	  xobs[i][j] = (xobs[i][j] - xcent[j]) * xampl[j];
	}
      yobs[i] = (yobs[i]-ycent) * yampl;
    }
 
  (void)fclose(fp);
}
/******************************************************************************
	Wavelet network for approximation
        simulation()
        by Qinghua ZHANG
        Last change: 10 April 1991
*******************************************************************************/


double
simulation(double *xsim)
{
  double	rval;
 
  switch(simfun)
    {
    case 1:
      {
	rval = xsim[0] * xsim[0] * xsim[0];
      }
      break;
    case 2:
      {
	rval = exp(-0.5 * xsim[0] - 0.5) * sin((3.0 * xsim[0] + 7.0) * xsim[0]);
      }
      break;
    case 3:
      {
	if(xsim[0]<-0.2) rval = -2.186 * xsim[0] - 1.2864;
	else
	  {
	    if(xsim[0]<0.0) rval = 4.246 * xsim[0];
	    else rval = exp(-0.5 * xsim[0] - 0.5) * sin((3.0 * xsim[0] + 7.0) * xsim[0]);
	  }
      }
      break;
    case 4:
      {
	rval = xsim[0] * xsim[0] - xsim[1] * xsim[1];
      }
      break;
    case 5:
      {
	rval = (xsim[0] * xsim[0] - xsim[1] * xsim[1]) * sin(5.0 * xsim[0]);;
      }
      break;
    case 6:
      {
	rval = xsim[0] * xsim[0] + xsim[1] * xsim[1] - xsim[2] * xsim[2];
      }
      break;
    }/*** switch ***/
 
  return(rval);
}

/******************************************************************************
	Wavelet network for approximation
        update()
        by Qinghua ZHANG
        Last change: 2 April 1991
*******************************************************************************/


void
update(void)
{
  int	l, i;
  double	*xt, *xr, *xd, *bufvec, e, dw, *dt, *ds, *dr,
    *dwave, volumetotal, volumeone, supp, rnorm,
    forward(double *x), wavelet(double *xvec), infnormat(double *mat, int m, int n);
	

  xt = (double *)calloc((unsigned)varnb, sizeof(double));
  xr = (double *)calloc((unsigned)varnb, sizeof(double));
  xd = (double *)calloc((unsigned)varnb, sizeof(double));
  bufvec = (double *)calloc((unsigned)varnb, sizeof(double));
  dt = (double *)calloc((unsigned)varnb, sizeof(double));
  ds = (double *)calloc((unsigned)varnb, sizeof(double));
  dr = (double *)calloc((unsigned)(varnb * varnb), sizeof(double));
  dwave = (double *)calloc((unsigned)varnb, sizeof(double));
 
  g = forward(x);
  e = g - y;
 
  gbar = gbar - gam * e;
 
  for(l=0; l<termnb; l++)
    {
      submm(xt, x, t[l], varnb, 1);
      multmm(xr, r[l], xt, varnb, varnb, 1);
      divivv(xd, xr, s[l], varnb);
      dwavelet(dwave, xd);
   
      /*** gradient ***/
      dw = e * wavelet(xd);
   
      divivv(bufvec, dwave, s[l], varnb);
      multmm(dt, bufvec, r[l], 1, varnb, varnb);
      multsm(dt, (-e * w[l]), dt, varnb, 1);
   
      multvv(ds, xr, dwave, varnb);
      multvv(bufvec, s[l], s[l], varnb);
      divivv(ds, ds, bufvec, varnb);
      multsm(ds, (-e * w[l]), ds, varnb, 1);
   
      if(varnb > 1)
	{
	  divivv(bufvec, dwave, s[l], varnb);
	  multmm(dr, bufvec, xt, varnb, 1, varnb);
	  multsm(dr, (e * w[l]), dr, varnb, varnb);
	}
   
      /*** up to date ***/
      w[l] = w[l] - gam * dw;
   
      multsm(bufvec, gam, dt, varnb, 1);
      submm(t[l], t[l], bufvec, varnb, 1); 
   
      multsm(bufvec, gam, ds, varnb, 1);
      submm(s[l], s[l], bufvec, varnb, 1);
   
   
    }
  cfree(xt); cfree(xr); cfree(xd); cfree(bufvec);
  cfree(dt); cfree(dr); cfree(ds); cfree(dwave);
 
  /*** projection required by constraints ***/
  for(l=0; l<termnb; l++)
    {
      for(i=0; i<varnb; i++)
	{
	  if(t[l][i] < domainmin) t[l][i] = domainmin;
	  if(t[l][i] > domainmax) t[l][i] = domainmax;
     
	  if(s[l][i] < epsilon) s[l][i] = epsilon;
	}
    }
 
  volumetotal = 0.0;
  for(l=0; l<termnb; l++)
    {
      volumeone = 1.0;
      for(i=0; i<varnb; i++)
	{
	  volumeone = volumeone * s[l][i];
	}
      volumetotal = volumetotal + volumeone;
    }
  if(volumetotal < volume)
    {
      supp = (volume - volumetotal) / ((double)termnb);
   
      for(l=0; l<termnb; l++)
	{
	  volumeone = 1.0;
	  for(i=0; i<varnb; i++)
	    {
	      volumeone = volumeone * s[l][i];
	    }
	  supp = pow((volumeone + supp) / volumeone, 1.0 / (double)varnb);
   
	  for(i=0; i<varnb; i++)
	    {
	      s[l][i] = s[l][i] * supp;
	    }
	}
    } 
}
/******************************************************************************
	Wavelet network for approximation
        wavelet.c
        by Qinghua ZHANG
        Last change: 3 April 1991
*******************************************************************************/



double
wavelet(double *xvec)
{
  int	l;
  double	rval, singlewave(double xvar);

  rval = 1.0;
  for(l=0; l<varnb; l++)
    {
      rval = rval * singlewave(xvec[l]);
    }
  return(rval);
}


dwavelet(double *dwave, double *xvec)
{
  int	i, j;
  double	singlewave(double xvar), dsinglewave(double xvar);

  for(i=0; i<varnb; i++)
    {
      dwave[i] = 1.0;
      for(j=0; j<i; j++)
	{
	  dwave[i] = dwave[i] * singlewave(xvec[j]);
	}
      dwave[i] = dwave[i] * dsinglewave(xvec[i]);
      for(j=i+1; j<varnb; j++)
	{
	  dwave[i] = dwave[i] * singlewave(xvec[j]);
	}
    }
}

double
singlewave(double xvar)
{
  return(-4.0 * xvar * exp(-2.0 * xvar * xvar));
}

double
dsinglewave(double xvar)
{
  return(4.0 * exp(-2.0 * xvar * xvar) * (4.0 * xvar * xvar - 1.0));
}
/******************************************************************************
	Wavelet network for approximation
        
        by Qinghua ZHANG
        Last change: 5 April 1991
*******************************************************************************/





double
wnet(double *xvec)
{
  int	l;
  double	rval, *xt, *xa, wavelet(double *xvec);
 
  xt = (double *)calloc((unsigned)varnb, sizeof(double));
  xa = (double *)calloc((unsigned)varnb, sizeof(double));
  rval = gbar;
  for(l=0; l<termnb; l++)
    {
      submm(xt, xvec, t[l], varnb, 1);
      multmm(xa, affine[l], xt, varnb, varnb, 1);
      rval = rval + w[l] * wavelet(xa);
    }
  cfree(xt); cfree(xa);
  return(rval);
}
/******************************************************************************
	Wavelet network for approximation
        writeresult()
        by Qinghua ZHANG
        Last change: 2 April 1991
*******************************************************************************/


void
writeresult(void)
{
  FILE	*fp;
  int	l, i, j;

 
 
  gbar = gbar / yampl + ycent;
  for(l=0; l<termnb; l++)
    {
      for(i=0; i<varnb; i++)
	{
	  t[l][i] = t[l][i] / xampl[i] + xcent[i];  
	}
   
      for(i=0; i<varnb; i++)
	{
	  for(j=0; j<varnb; j++)
	    {
	      affine[l][i * varnb + j] =
       		(1.0 / s[l][i]) * r[l][i * varnb + j] * xampl[j];
	    }
	}
   
      w[l] = w[l] / yampl;
    }
}
